Package org.apache.log4j.chainsaw.help

## Class HelpManager

- java.lang.Object
- - org.apache.log4j.chainsaw.help.HelpManager

-     public final class HelpManager
      extends Object

  Singleton help manager where objects can register to display Help for something, an independant viewer can register to be notified when the requested Help URL changes and can display it appropriately. This class effectively decouples the help requester from the help implementation (if any!)
  Author:
    Paul Smith <psmith@apache.org>

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addPropertyChangeListener​(PropertyChangeListener listener)` |
    `void` | `addPropertyChangeListener​(String propertyName, PropertyChangeListener listener)` |
    `void` | `firePropertyChange​(PropertyChangeEvent evt)` |
    `void` | `firePropertyChange​(String propertyName, boolean oldValue, boolean newValue)` |
    `void` | `firePropertyChange​(String propertyName, int oldValue, int newValue)` |
    `void` | `firePropertyChange​(String propertyName, Object oldValue, Object newValue)` |
    `URL` | `getHelpForClass​(Class c)` | Determines the most appropriate Help resource for a particular class or returns ChainsawConstants.URL_PAGE_NOT_FOUND if there is no resource located.
    `static HelpManager` | `getInstance()` |
    `void` | `removePropertyChangeListener​(PropertyChangeListener listener)` |
    `void` | `removePropertyChangeListener​(String propertyName, PropertyChangeListener listener)` |
    `void` | `setHelpURL​(URL helpURL)` | The current Help URL that should be displayed, and is a PropertyChangeListener supported property.
    `void` | `showHelpForClass​(Class c)` | Given a class, and that it belongs within the org.apache.log4j project, sets the URL to the JavaDoc for that class.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### setHelpURL

          public void setHelpURL​(URL helpURL)

      The current Help URL that should be displayed, and is a PropertyChangeListener supported property.

      This method ALWAYS fires property change events even if the value is the same (the oldvalue of the event will be null)

      Parameters:
        `helpURL` -

    - #### addPropertyChangeListener

          public void addPropertyChangeListener​(PropertyChangeListener listener)

      Parameters:
        `listener` -

    - #### addPropertyChangeListener

          public void addPropertyChangeListener​(String propertyName,
                                                PropertyChangeListener listener)

      Parameters:
        `propertyName` -
        `listener` -

    - #### firePropertyChange

          public void firePropertyChange​(PropertyChangeEvent evt)

      Parameters:
        `evt` -

    - #### firePropertyChange

          public void firePropertyChange​(String propertyName,
                                         boolean oldValue,
                                         boolean newValue)

      Parameters:
        `propertyName` -
        `oldValue` -
        `newValue` -

    - #### firePropertyChange

          public void firePropertyChange​(String propertyName,
                                         int oldValue,
                                         int newValue)

      Parameters:
        `propertyName` -
        `oldValue` -
        `newValue` -

    - #### firePropertyChange

          public void firePropertyChange​(String propertyName,
                                         Object oldValue,
                                         Object newValue)

      Parameters:
        `propertyName` -
        `oldValue` -
        `newValue` -

    - #### removePropertyChangeListener

          public void removePropertyChangeListener​(PropertyChangeListener listener)

      Parameters:
        `listener` -

    - #### removePropertyChangeListener

          public void removePropertyChangeListener​(String propertyName,
                                                   PropertyChangeListener listener)

      Parameters:
        `propertyName` -
        `listener` -

    - #### getInstance

          public static HelpManager getInstance()

    - #### showHelpForClass

          public void showHelpForClass​(Class c)

      Given a class, and that it belongs within the org.apache.log4j project, sets the URL to the JavaDoc for that class.
      Parameters:
        `c` -

    - #### getHelpForClass

          public URL getHelpForClass​(Class c)

      Determines the most appropriate Help resource for a particular class or returns ChainsawConstants.URL_PAGE_NOT_FOUND if there is no resource located.
      Returns:
        URL